package fr.takima.lotka_volterra;

import fr.takima.lotka_volterra.mating.PredatorMatingProperties;
import fr.takima.lotka_volterra.mating.PreyMatingProperties;
import fr.takima.lotka_volterra.moving.MapProperties;
import fr.takima.lotka_volterra.moving.PredatorMovingProperties;
import fr.takima.lotka_volterra.moving.PreyMovingProperties;
import fr.takima.lotka_volterra.predation.PredationProperties;
import fr.takima.lotka_volterra.predator.DefaultPredatorIdGenerator;
import fr.takima.lotka_volterra.predator.PredatorIdGenerator;
import fr.takima.lotka_volterra.prey.DefaultPreyIdGenerator;
import fr.takima.lotka_volterra.prey.PreyIdGenerator;
import fr.takima.lotka_volterra.simulation.SimulationProperties;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.Random;

@Configuration
@EnableConfigurationProperties({
        MapProperties.class,
        PredationProperties.class,
        PredatorMatingProperties.class,
        PredatorMovingProperties.class,
        PreyMatingProperties.class,
        PreyMovingProperties.class,
        SimulationProperties.class
})
public class AppConfiguration {

    private static int PREY_ID = 0;
    private static int PREDATOR_ID = 0;

    @Bean
    public PreyIdGenerator preyIdGenerator() {
        return new DefaultPreyIdGenerator(() -> String.valueOf(PREY_ID++));
    }

    @Bean
    public PredatorIdGenerator predatorIdGenerator() {
        return new DefaultPredatorIdGenerator(() -> String.valueOf(PREDATOR_ID++));
    }

    @Bean
    public Random random() {
        return new Random();
    }

}
