package fr.takima.lotka_volterra.common;

import fr.takima.lotka_volterra.common.value.BigDecimalValue;
import fr.takima.lotka_volterra.validator.GreaterThanValidator;

import java.math.BigDecimal;

public final class Distance extends BigDecimalValue {

    public Distance(BigDecimal value) {
        super(value);
        new GreaterThanValidator<>("value", value, BigDecimal.ZERO).validate();
    }

    public Distance(Integer value) {
        this(new BigDecimal(value));
    }

    public boolean isLessThan(Distance other) {
        return value.compareTo(other.value) <= 0;
    }

}
