package fr.takima.lotka_volterra.common;

import fr.takima.lotka_volterra.common.value.BigDecimalValue;
import fr.takima.lotka_volterra.validator.GreaterThanValidator;
import fr.takima.lotka_volterra.validator.LowerThanValidator;

import java.math.BigDecimal;

public final class Probability extends BigDecimalValue {

    public Probability(BigDecimal value) {
        super(value);
        new GreaterThanValidator<>("value", value, BigDecimal.ZERO).validate();
        new LowerThanValidator<>("value", value, BigDecimal.ONE).validate();
    }

    @Override
    public String toString() {
        return "Probability{" +
                "value=" + value +
                '}';
    }

}
