package fr.takima.lotka_volterra.common.value;

import fr.takima.lotka_volterra.validator.NotNullValidator;

import java.math.BigDecimal;
import java.util.Objects;

public abstract class BigDecimalValue {

    protected final BigDecimal value;

    public BigDecimalValue(BigDecimal value) {
        new NotNullValidator("value", value).validate();
        this.value = value;
    }

    public final BigDecimal value() {
        return value;
    }

    @Override
    public final boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        var that = (BigDecimalValue) o;
        return value.equals(that.value);
    }

    @Override
    public final int hashCode() {
        return Objects.hash(value);
    }

    @Override
    public String toString() {
        return "BigDecimalValue{" +
                "value=" + value +
                '}';
    }

}
