package fr.takima.lotka_volterra.common.value;

import fr.takima.lotka_volterra.validator.NotNullValidator;

import java.util.Objects;

public abstract class IntValue {

    protected final Integer value;

    public IntValue(Integer value) {
        new NotNullValidator("value", value).validate();
        this.value = value;
    }

    public final Integer value() {
        return value;
    }

    @Override
    public final boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        var intValue = (IntValue) o;
        return value.equals(intValue.value);
    }

    @Override
    public final int hashCode() {
        return Objects.hash(value);
    }

    @Override
    public String toString() {
        return "IntValue{" +
                "value=" + value +
                '}';
    }

}
