package fr.takima.lotka_volterra.common.value;

import fr.takima.lotka_volterra.validator.NotNullValidator;

import java.util.Objects;

public abstract class StringValue {

    protected final String value;

    public StringValue(String value) {
        new NotNullValidator("value", value).validate();
        this.value = value;
    }

    public final String value() {
        return value;
    }

    @Override
    public final boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        var that = (StringValue) o;
        return value.equals(that.value);
    }

    @Override
    public final int hashCode() {
        return Objects.hash(value);
    }

    @Override
    public String toString() {
        return "StringValue{" +
                "value='" + value + '\'' +
                '}';
    }

}
