package fr.takima.lotka_volterra.mating;

import fr.takima.lotka_volterra.common.Probability;
import fr.takima.lotka_volterra.common.Distance;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.util.Random;

@Component
public class DefaultPredatorMatingConfigurer implements MatingConfigurer {

    private final Random random;
    private final Distance maxDistance;
    private final Probability successProbability;

    public DefaultPredatorMatingConfigurer(Random random, PredatorMatingProperties properties) {
        this.random = random;
        this.maxDistance = new Distance(properties.getMaxDistance());
        this.successProbability = new Probability(BigDecimal.valueOf(properties.getSuccessProbability()));
    }

    @Override
    public Random random() {
        return random;
    }

    @Override
    public Distance maxDistance() {
        return maxDistance;
    }

    @Override
    public Probability successProbability() {
        return successProbability;
    }

}
