package fr.takima.lotka_volterra.moving;

import org.springframework.stereotype.Component;

@Component
public final class DefaultMapConfigurer implements MapConfigurer {

    private final Integer minX;
    private final Integer maxX;
    private final Integer minY;
    private final Integer maxY;

    public DefaultMapConfigurer(MapProperties properties) {
        this.minX = properties.getMinX();
        this.maxX = properties.getMaxX();
        this.minY = properties.getMinY();
        this.maxY = properties.getMaxY();
    }

    @Override
    public Integer minX() {
        return minX;
    }

    @Override
    public Integer maxX() {
        return maxX;
    }

    @Override
    public Integer minY() {
        return minY;
    }

    @Override
    public Integer maxY() {
        return maxY;
    }

}
