package fr.takima.lotka_volterra.moving;

import fr.takima.lotka_volterra.common.Distance;
import org.springframework.stereotype.Component;

import java.util.Random;

@Component
public class DefaultPreyMovingConfigurer implements MovingConfigurer {

    private final Random random;
    private final Distance maxDistance;

    public DefaultPreyMovingConfigurer(Random random, PreyMovingProperties properties) {
        this.random = random;
        this.maxDistance = new Distance(properties.getMaxDistance());
    }

    @Override
    public Random random() {
        return random;
    }

    @Override
    public Distance maxDistance() {
        return maxDistance;
    }

}
