package fr.takima.lotka_volterra.predation;

import fr.takima.lotka_volterra.predator.Predator;
import fr.takima.lotka_volterra.prey.Prey;
import fr.takima.lotka_volterra.validator.NotNullValidator;

import java.util.Set;

public record PredationResult(Set<Prey> preys, Set<Predator> predators) {

    public PredationResult {
        new NotNullValidator("preys", preys).validate();
        new NotNullValidator("predators", predators).validate();
    }

}
