package fr.takima.lotka_volterra.predator;

import fr.takima.lotka_volterra.common.StringIdGenerator;
import fr.takima.lotka_volterra.validator.NotNullValidator;

public final class DefaultPredatorIdGenerator implements PredatorIdGenerator {

    private final StringIdGenerator generator;

    public DefaultPredatorIdGenerator(StringIdGenerator generator) {
        new NotNullValidator("generator", generator).validate();
        this.generator = generator;
    }

    @Override
    public PredatorId generate() {
        return new PredatorId(generator.generate());
    }

}
