package fr.takima.lotka_volterra.prey;

import fr.takima.lotka_volterra.common.StringIdGenerator;
import fr.takima.lotka_volterra.validator.NotNullValidator;

public final class DefaultPreyIdGenerator implements PreyIdGenerator {

    private final StringIdGenerator generator;

    public DefaultPreyIdGenerator(StringIdGenerator generator) {
        new NotNullValidator("generator", generator).validate();
        this.generator = generator;
    }

    @Override
    public PreyId generate() {
        return new PreyId(generator.generate());
    }

}
