package fr.takima.lotka_volterra.prey;

import fr.takima.lotka_volterra.mating.MatingEntity;
import fr.takima.lotka_volterra.moving.Position;
import fr.takima.lotka_volterra.validator.NotNullValidator;

import java.util.Objects;

public record Prey(PreyId id, Position position) implements MatingEntity<Prey> {

    public Prey {
        new NotNullValidator("id", id).validate();
        new NotNullValidator("position", position).validate();
    }

    public Prey withPosition(Position newPosition) {
        return new Prey(id, newPosition);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        var prey = (Prey) o;
        return id.equals(prey.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

}
