package fr.takima.lotka_volterra.simulation;

import fr.takima.lotka_volterra.common.value.PositiveInt;
import fr.takima.lotka_volterra.validator.NotNullValidator;

public record Populations(
        PositiveInt preys,
        PositiveInt predators) {

    public Populations {
        new NotNullValidator("preys", preys).validate();
        new NotNullValidator("predators", predators).validate();
    }

    @Override
    public String toString() {
        return "preys=" + preys +
                ", predators=" + predators;
    }

}
