package fr.takima.lotka_volterra.simulation;

import fr.takima.lotka_volterra.common.value.PositiveInt;
import fr.takima.lotka_volterra.mating.MatingConfigurer;
import fr.takima.lotka_volterra.moving.MapConfigurer;
import fr.takima.lotka_volterra.moving.MovingConfigurer;
import fr.takima.lotka_volterra.predation.PredationConfigurer;
import fr.takima.lotka_volterra.predator.PredatorChildMaking;
import fr.takima.lotka_volterra.prey.PreyChildMaking;

public interface SimulationConfigurer {

    PositiveInt initialPreyCount();

    PositiveInt initialPredatorCount();

    PositiveInt stepCount();

    PreyChildMaking preyChildMaking();

    PredatorChildMaking predatorChildMaking();

    MatingConfigurer preyMating();

    MatingConfigurer predatorMating();

    MovingConfigurer preyMoving();

    MovingConfigurer predatorMoving();

    PredationConfigurer predation();

    MapConfigurer map();

}
