package fr.takima.lotka_volterra.validator;

public class GreaterThanValidator<T extends Comparable<T>> extends Validator<T> {

    private final T min;

    public GreaterThanValidator(String name, T value, T min) {
        super(name, value);
        new NotNullValidator("min", min).validate();
        this.min = min;
    }

    @Override
    public void validate() {
        if (value.compareTo(min) < 0) {
            throw new IllegalArgumentException(name + " must be greater than or equal to " + min);
        }
    }

}
