package fr.takima.lotka_volterra.validator;

public class LowerThanValidator<T extends Comparable<T>> extends Validator<T> {

    private final T max;

    public LowerThanValidator(String name, T value, T max) {
        super(name, value);
        new NotNullValidator("max", max).validate();
        this.max = max;
    }

    @Override
    public void validate() {
        if (value.compareTo(max) > 0) {
            throw new IllegalArgumentException(name + " must be lower than or equal to " + max);
        }
    }

}
